// Ansteuerung eines Lautsprechers an Pin 1.2
// 2011-12-04

#include "speaker.h"
#include "io430.h"
#include "intrinsics.h"
#include <stdbool.h>

static bool (*wdtCallback)(void);
static volatile bool done = false;

#pragma vector = WDT_VECTOR
__interrupt void WDT_ISR(void)
{
  bool result = wdtCallback();
  done |= result;
}

void initialize(bool (*callback)(void))
{
  wdtCallback = callback;
  
  WDTCTL = WDTPW | WDTTMSEL;
  
  BCSCTL1 = CALBC1_1MHZ;
  DCOCTL = CALDCO_1MHZ;
  
  P1DIR &= ~BIT2; // Sound erst aus!
  P1SEL |= BIT2;
  
  TACCR0 = 1000000/440/2;
  
  TACCTL1 = OUTMOD_4;
  TACTL = MC_1 | TASSEL_2 | TACLR;

  TACCR0 = 7645/2;
  TACTL |= TACLR;
  
  IE1 |= WDTIE;
  __enable_interrupt();
}

void soundOn(void)
{
  P1DIR |= BIT2;
}

void soundOff(void)
{
  P1DIR &= ~BIT2;
}

bool isDone(void)
{
  return done;
}